# -*- coding: utf-8 -*-
# This file is part of Lyric Grabber
# Lyric Grabber is not affiliated with azlyrics.com

'''
Lyric Grabber - download, display and save lyrics from the web
Copyright (C) 2014 Timothy Welborn

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

contact:
welborntimothy@gmail.com

The full license can be found in "license.txt"
'''

from re import sub
import urllib.request


class Handler(object):

    def __init__(self):
        self.URL = "http://www.azlyrics.com/lyrics/"
        self.FileName = 'untitled'

    def Main(self, Artist=None, Song=None, Debug=False):
        if Debug:
            return(self.Grab(Debug=True))

        URI = self.Prepare(Artist, Song)

        try:
            Lyrics = self.Grab(URI)
            return(Lyrics)
        except:
            return(1)

    def Grab(self, URI=None, Debug=False):
        # download and parse the lyrics
        if Debug:
            try:
                urllib.request.urlopen("http://www.azlyrics.com/")
                return(0)
            except:
                return(1)

        Response = urllib.request.urlopen(self.URL + URI)
        Data = Response.read()
        HTML = Data.decode('utf-8')

        Raw = (HTML.split('<!-- start of lyrics -->')[1]
            ).split('<!-- end of lyrics -->')[0]
        Lyrics = sub('<[^<]+?>', '', Raw)
        return Lyrics

    def Prepare(self, Artist, Song):
        # format the artist and song, generate filename
        self.FileName = '%s - %s' % (Artist, Song)

        Artist = Artist.lower().replace(' ', '')
        Artist = sub(r'\W+', '', Artist)
        Song = Song.lower().replace(' ', '')
        Song = sub(r'\W+', '', Song)

        return('%s/%s.html' % (Artist, Song))
