# -*- coding: utf-8 -*-
# This file is part of Lyric Grabber
# Lyric Grabber is not affiliated with azlyrics.com

'''
Lyric Grabber - download, display and save lyrics from the web
Copyright (C) 2014 Timothy Welborn

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

contact:
welborntimothy@gmail.com

The full license can be found in "license.txt"
'''

from tkinter import *
from tkinter.scrolledtext import ScrolledText
from tkinter.ttk import *


class Widgets(object):

    def __init__(self):
        pass

    def Canvas_init(self, Parent):

        self.TopCanvas = Canvas(Parent.Root, highlightthickness=0)
        self.TopCanvas.pack(side='top', anchor='w')

        self.BottomCanvas = Canvas(Parent.Root, highlightthickness=0)
        self.BottomCanvas.pack(side='bottom')

    def TopWidgets(self, Parent):

        ArtistLabel = Label(self.TopCanvas, text="Artist:")
        ArtistLabel.grid(padx=10, pady=10, row=0, column=0)

        Parent.Artist = StringVar()
        Parent.ArtistEntry = Entry(self.TopCanvas, textvariable=Parent.Artist)
        Parent.ArtistEntry.grid(padx=10, pady=10, row=0, column=1)



        SongLabel = Label(self.TopCanvas, text="Song:")
        SongLabel.grid(padx=10, pady=10, row=1, column=0)

        Parent.Song = StringVar()
        SongEntry = Entry(self.TopCanvas, textvariable=Parent.Song)
        SongEntry.grid(padx=10, pady=10, row=1, column=1)

        GrabButton = Button(self.TopCanvas, text="Grab", command=Parent.Fetch)
        GrabButton.grid(padx=10, pady=10, row=1, column=2)

        ClearButton = Button(self.TopCanvas, text="Clear",
            command=Parent.ClearEntry)
        ClearButton.grid(padx=10, pady=10, row=1, column=3)

        StatusLabel = Label(self.TopCanvas, text="Status:")
        StatusLabel.grid(padx=10, pady=10, row=2, column=0)

        Parent.Status = Label(self.TopCanvas, width=30, text="Waiting")
        Parent.Status.grid(padx=10, pady=10, row=2, column=1, columnspan=2)

    def BottomWidgets(self, Parent):

        Parent.LyricST = ScrolledText(self.BottomCanvas, wrap="word")
        Parent.LyricST.pack(padx=10, pady=10)

        QuitButton = Button(self.BottomCanvas, text="Quit", command=exit)
        QuitButton.pack(padx=10, pady=10, side="left")

        SaveButton = Button(self.BottomCanvas, text="Save",
            command=Parent.SaveFile)
        SaveButton.pack(padx=10, pady=10, side="right")

        ResetButton = Button(self.BottomCanvas, text="Reset",
            command=Parent.Reset)
        ResetButton.pack(padx=10, pady=10, side="right")

        NoticeLabel = Label(self.BottomCanvas,
            text="Lyrics from http://www.azlyrics.com/\n" +
            "Lyrics Grabber is not associated with azlyrics.com",
            justify="center")
        NoticeLabel.pack(padx=10, pady=10)

    def Establish(self, Parent):
        self.Canvas_init(Parent)
        self.TopWidgets(Parent)
        self.BottomWidgets(Parent)
