#!/usr/bin/python3
# Lyric Grabber is not affiliated with azlyrics.com

'''
Lyric Grabber - download, display and save lyrics from the web
Copyright (C) 2014 Timothy Welborn

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

contact:
welborntimothy@gmail.com

The full license can be found in "license.txt"
'''

from sys import version

# if python version < 3: prompt python 3 installation for compatibility
if int(version.split('.')[0]) < 3:

	import webbrowser
	from Tkinter import *

	Root = Tk()
	Root.title("Lyric Grabber is not compatible")
	Root.resizable(0, 0)

	Icon = PhotoImage(file="icon.png")
	Root.tk.call("wm", "iconphoto", Root, Icon)

	# widgets
	Info = Label(Root,
		text="Python 3.x is required to run Lyric Grabber.\n\n" + 
		"A Python 2.x version will not be written or maintained,\n" +
		"as Python 3 is the future standard.\n" +
		"Alternatively, you may port it yourself.\n\n" +
		"If you already have Python 3 installed try running\n" +
		"Lyric Grabber with your Python 3 executable.",
		justify="center")
	Info.pack(padx=10, pady=10)

	Cancel = Button(Root, width=10, text="Okay", command=exit)
	Cancel.pack(padx=10, pady=10, side="left")

	GetPython = Button(Root, width=10, text="Get Python 3",
		command = lambda: webbrowser.open_new_tab(
		"https://www.python.org/downloads/"))
	GetPython.pack(padx=10, pady=10, side="right")

	# center the window
	Root.update()
	winx = Root.winfo_width()
	winy = Root.winfo_height()
	scrx = Root.winfo_screenwidth()
	scry = Root.winfo_screenheight()
	Root.geometry(
		str(winx) + 'x' + str(winy) + '+' +
		str((scrx // 2) - (winx // 2)) + '+' +
		str((scry // 2) - (winy // 2)))

	Root.mainloop()

	exit()

# run the package appropriately
from sys import executable
from subprocess import Popen
import os

if os.name != "nt":
	Popen(executable + " LyricGrabber.app", shell=True)

else:
	raw = executable.split(os.sep)
	raw.remove(raw[len(raw)-1])
	pyw = ''
	for item in raw:
		pyw += item + os.sep
	pyw += "pythonw.exe"
	Popen(pyw + " LyricGrabber.app", shell=True)
